<template>
  <div class="map-container">
    <div v-show="mapFilePath" ref="parent" class="canvas-wrapper">
      <transition name="fade">
        <div v-if="overlay" class="overlay">
          {{ overlay.text }}
          <div v-if="overlay.actions" class="overlay-actions">
            <button
              v-for="action in overlay.actions"
              :key="action.name"
              type="button"
              class="btn"
              @click="$store.dispatch(action.name, action.payload)"
            >
              {{ action.text }}
            </button>
          </div>
        </div>
      </transition>
      <CharacterAvatar />
      <HeartContainer v-if="$route.name === 'shadow-world'" />
      <span v-if="playerState.areRemainingYearsVisible" class="remaining-years">
        remaining years: {{ 80 - playerState.age }}</span
      >
    </div>
    <div v-if="!mapFilePath" class="loading-text">Loading map…</div>
  </div>
</template>

<script>
import Game from '~/phaser/game'
import MapScene from '~/phaser/map-scene'
import { createNamespacedHelpers } from 'vuex'
import {
  setMapData,
  useDoor,
  setPlayerPosition,
  setStartPosition,
  interaction
} from '~/phaser/custom-events'
import CharacterAvatar from './character-avatar'
import HeartContainer from './heart-container'

const storeModules = {
  debug: createNamespacedHelpers('debug'),
  map: createNamespacedHelpers('map'),
  player: createNamespacedHelpers('player')
}

export default {
  components: {
    CharacterAvatar,
    HeartContainer
  },

  data() {
    return {
      showLoadingText: false
    }
  },

  computed: {
    ...storeModules.map.mapState(['mapFilePath', 'overlay', 'hiddenLayers']),
    ...storeModules.map.mapGetters(['hasOverlay']),
    ...storeModules.debug.mapState({
      debugFlags(state) {
        return state.flags
      }
    }),
    ...storeModules.player.mapState({
      playerState(state) {
        return state
      }
    })
  },

  watch: {
    mapFilePath(newValue, oldValue) {
      if (this.scene) {
        this.game.scene.remove(this.scene)
      }

      const baseUrl = this.$router.options.base
      this.scene = new MapScene({
        baseUrl,
        mapFilePath: newValue,
        debugFlags: this.debugFlags,
        playerState: this.playerState,
        mapState: {
          hasOverlay: () => this.hasOverlay,
          hiddenLayers: this.hiddenLayers
        }
      })
      this.game.scene.add(null, this.scene, true)

      const { events } = this.scene
      events.on(useDoor, this.handleDoor)
      events.on(setMapData, this.setMapData)
      events.on(setStartPosition, this.setStartPosition)
      events.on(setPlayerPosition, this.setPlayerPosition)
      events.on(interaction, layerName => {
        const { name: routeName } = this.$route
        if (
          routeName === 'shadow-world' &&
          layerName.indexOf('SALESMAN_') === 0
        ) {
          this.$store
            .dispatch('fight/setEnemyName', layerName)
            .then(() => this.$router.push('/schni_schna_schnu'))
        } else {
          this.$store.dispatch(`${routeName}/${layerName}/activate`, {
            routeName,
            layerName
          })
        }
      })
    },

    hiddenLayers(newValue) {
      this.scene.hideLayers(newValue)
    },

    'overlay.actions'(newValue) {
      if (newValue) {
        this.$nextTick(() =>
          this.$el.querySelector('.overlay-actions .btn').focus()
        )
      }
    }
  },

  mounted() {
    const { parent } = this.$refs
    this.game = new Game({ parent })
    this.game.events.once('ready', () => {
      this.$emit('ready')
      const loadingText = this.$el.querySelector('.loading-text')
      if (loadingText) {
        loadingText.classList.add('fade-in')
      }
    })
  },

  beforeDestroy() {
    this.game.destroy()
  },

  methods: {
    ...storeModules.map.mapActions(['setMapFilePath', 'setMapData']),
    ...storeModules.player.mapActions({
      setStartPosition: 'setStartPosition',
      setPlayerPosition: 'setTilePosition',
      resetPlayerPosition: 'resetTilePosition'
    }),

    handleDoor(doorProperties) {
      this.resetPlayerPosition()

      const newMap = doorProperties.find(property => property.name === 'map')
      if (newMap) {
        const newMapFilePath = `maps/${newMap.value}.json`
        this.setMapFilePath(newMapFilePath)
      }

      const newRoute = doorProperties.find(
        property => property.name === 'route'
      )
      if (newRoute) {
        this.$router.push(newRoute.value)
      }
    }
  }
}
</script>

<style>
.map-container {
  position: absolute;
  left: 0;
  right: 0;
  top: 0;
  bottom: 0;
  display: flex;
}

.canvas-wrapper {
  position: relative;
  margin: auto;
  padding: 21px;
}

.loading-text {
  font-size: 36px;
  margin: auto;
  visibility: hidden;
  opacity: 0;
}

.loading-text.fade-in {
  visibility: visible;
  opacity: 1;
  transition: visibility 0s linear 0s, opacity 300ms;
}

.map-container .overlay {
  bottom: 21px;
  left: 21px;
  right: 21px;
  height: 160px;
}

.remaining-years {
  position: absolute;
  top: 24px;
  right: 80px;
  color: black;
  font-size: 24px;
  font-weight: bold;
  text-shadow: 0 0 4px red;
}
</style>
